'''


@author: cchappet
'''
import sys,os
import time

from PyQt4 import QtCore
from PyQt4 import Qt,QtGui

import PyTango

def test1(event):
    print event

def test2(event):
    print event

from PyGMT.GMTGui.QtDigitalDisplay import QtDigitalDisplay

class EventManager():
    
    def __init__(self,deviceAdr, attrAdr,fct,app):
        #Subscribe to the counter
        self.pyds = PyTango.DeviceProxy(deviceAdr)
        self.id_event = self.pyds.subscribe_event(attrAdr, PyTango.EventType.CHANGE_EVENT, self.ReceiveTangoEvent, stateless = True)
        self.app = app
        
        self.wd = QtGui.QLabel("TEST")
        self.wd.show()
        
        #The QUIT button close the application
        self.wdButton = QtGui.QPushButton("QUIT")
        self.wdButton.clicked.connect(self.stop)
        self.wdButton.show()

        #Create a Signal to display the Tango Value
        QtCore.QObject.connect(Qt.qApp, QtCore.SIGNAL("updateData(PyQt_PyObject)"),self.UpdateGui)
        
    def ReceiveTangoEvent(self,event):
        print str(event.attr_value.value)
        Qt.qApp.emit(QtCore.SIGNAL("updateData(PyQt_PyObject)"),str(event.attr_value.value))        

    def UpdateGui(self,data):
        self.wd.setText(data)

    #Called by the QUIT button (OK in PyTango 8.1.6, CRASH in PyTango 9.2.0)
    def stop(self):        
        QtCore.QObject.disconnect(Qt.qApp, QtCore.SIGNAL("updateData(PyQt_PyObject)"),self.UpdateGui)
        self.pyds.unsubscribe_event(self.id_event) 
        self.app.quit()

        
if __name__ == "__main__": # pragma: no cover

    app = QtGui.QApplication(sys.argv)

    #The server push a counter
    ev1 = EventManager("test/TestDevice/TestDevice","trignumber",test1,app)
    
    sys.exit(app.exec_())  
